import es, cfglib
import spe

info = es.AddonInfo()
info.name     = "HurtMods"
info.version  = "1.0"
info.url      = "http://www.addons.eventscripts.com/addons/view/hurtmods"
info.basename = "hurtmods"
info.author   = "DanielB"
es.ServerVar('hurtmods_ver', info.version, 'HurtMods by DanielB').makepublic()

def load():
    spe.registerPreHook('player_hurt', pre_player_hurt)
    es.msg('#multi', '#green[HurtMods]#lightgreen Loaded!')
    
def unload():
    spe.unregisterPreHook('player_hurt', pre_player_hurt)
    es.msg('#multi', '#green[HurtMods]#lightgreen Unloaded')
    
def pre_player_hurt(ev):
    attacker = ev['attacker']
    victim = ev['userid']
    if int(attacker) and attacker != victim:
        weapon = ev['weapon']
        damage = ev['dmg_health']
        hitgroup = ev['hitgroup']
        
        bhg = settings.blocked_hitgroups
        if bhg != '0':
            if str(hitgroup) in bhg:
                health = es.getplayerprop(victim, 'CBasePlayer.m_iHealth')
                es.setplayerprop(victim, 'CBasePlayer.m_iHealth', health+damage)
                es.dbgmsg(0, 'Negating Damage (blocked HG)')
                return
        
        damagemods = settings.enable_damagemods
        if damagemods:
            if damagemods == 1:
                health = es.getplayerprop(victim, 'CBasePlayer.m_iHealth')
                multiplier = float(es.ServerVar('hm_wepmod_%s'%weapon))
                if multiplier == 0:
                    es.setplayerprop(victim, 'CBasePlayer.m_iHealth', health+damage)
                else:
                    es.setplayerprop(victim, 'CBasePlayer.m_iHealth', (damage+health)-(multiplier*damage))
                
            elif damagemods == 2:
                health = es.getplayerprop(victim, 'CBasePlayer.m_iHealth')
                es.setplayerprop(victim, 'CBasePlayer.m_iHealth', (damage+health)-(settings.damagemods_global*damage))
                
        
                
        
class Settings(object):
    config = cfglib.AddonCFG(es.getAddonPath('hurtmods') + '/settings.cfg')
    
    _blocked_hitgroups  = config.cvar('hm_blocked_hitgroups',    '0',  'HitGroups to disable, seperated by a ; (see http://www.eventscripts.com/pages/Hit_Groups) Set to 0 to disable'), str
    _enable_damagemods  = config.cvar('hm_enable_damagemods',    '2',  'Enable Damage Mods? (0=No,1=perweapon,2=global)'), int
    _damagemods_global  = config.cvar('hm_damagemods_global',    '1.5',  'If using hm_enable_damagemods 2, the damage multiplier'), float
    
    config.text('Per Weapon Configs - These take effect if using hm_enable_damagemods 1')
    
    for weapon in ['usp', 'glock', 'p228', 'deagle', 'fiveseven', 'elite', 'm3', 'xm1014', 'tmp',
    'mac10', 'ump45', 'mp5navy', 'p90', 'galil', 'ak47', 'm4a1', 'aug', 'sg522', 'm249', 'scout',
    'awp', 'sg550', 'g3sg1', 'knife', 'hegrenade', 'smokegrenade', 'flashbang']:
        config.cvar('hm_wepmod_%s'%weapon,    '1.0',  'Multiplier for the %s'%weapon), float
   
    config.execute()
   
    def __init__(self):
        self.config.write()
        
    def __getattr__(self, name):
        if hasattr(Settings, name):
            return super(Settings, self).__getattribute__(name)
           
        elif hasattr(Settings, '_'+name):
            val, func = super(Settings, self).__getattribute__('_'+name)
            return func(val)
           
        raise AttributeError, 'No such attribute "%s"'%name

settings = Settings()